      SUBROUTINE ACOND(IBLOW,TRETWB,TRETB)
C
C  AIR-CONDITIONER MODEL(BASED ON ORIGINAL EQNS IN SP43 MODEL)
C    EXCEPT THAT MORE TIME CONSTANTS ARE PROVIDED
C  NOTE:::::   THIS AIR-CONDITIONING MODEL HAS NEVER BEEN USED WITH
C              THE MULTIZONE MODEL HOUSE_II, SO EXPECT SOME MINOR
C              INTERFACE PROBLEMS.  SEE REF. 5, FILE C:\HII\SCR\S2.DOC
C              FOR MORE INFO ON THIS MODEL.
C
CMDK ACND
CMDK BLKGS2
CMDK BLKQGS
CMDK HUMIDC
CMDK INDIC1
CMDK OWETHR
CMDK TIMEB
      DIMENSION CONS13(4)
      PARAMETER (CPAIR=.24)
C      
C INPUTS IN NAMELIST INPAC:
C  ACAPAC  - SENSIBLE AND LATENT CAPACITY MULTIPLIER
C  APOWFAC - POWER MULTIPLIER
C  DTCAP   - TEMP DIFF BELOW TCAP AT WHICH LATENT CAPACITY IS ZERO,F
C  RECOVC - FRACTION OF A/C CAPACITY AVAILABLE AFTER TURN-OFF
C  REDC   - COOLING CAPACITY REDUCTION FACTOR
C  TCAP    - INDOOR WET BULB TEMP AT WHICH MODEL BEGINS TO SHUT OFF
C            LATENT CAPACITY,F     
C  TCEQIP   "ON" TIME CONST FOR REFR-SIDE TOTAL CLG CAPCY,HR
C  TCEQP0   "OFF" TIME CONST FOR REFR-SIDE TOTAL CLG CAPCY,HR
C  TCLAT0  "OFF" TIME CONST FOR LATENT CLG CAPCY,HR
C  TCLAT1  "ON" TIME CONST FOR LATENT CLG CAPCY,HR
      NAMELIST/INPAC/ACAPFAC,APOWFAC,DTCAP,RECOVC,REDC,TCAP,TCEQP0,
     +               TCLAT0,TCLAT1
C      
      DATA IACLS/-1/,IREAD/0/,TCAP/1./,DTCAP/1./
C  FROM HEAT PUMP PRODUCT LITERATURE
      DATA CFAC/0.835/,THOU/1000./,ACAPFAC/1./,APOWFAC/1./
      AFAC=CFAC/THOU
C
      IF(IREAD.EQ.0)THEN
C
        OPEN(16,FILE='TAPE16',STATUS='OLD',IOSTAT=IO16)
        IF(IO16.NE.0)THEN
          WRITE(60,*)' ACOND: CANT OPEN TAPE16 WITH NAMELIST INPAC '
          STOP ' ACOND: CANT OPEN TAPE16 WITH NAMELIST INPAC'
        ENDIF
        READ(16,INPAC,END=99)
        WRITE(60,INPAC)
        IF(REDC.EQ.0.)REDC=1.
        CFANPC=CFANPC*REDC
        EFANPC=EFANPC*REDC
        REWIND(16)
        WRITE(60,  510)
        DO 80 I=1, 3
C--------A (1, N) - A/C TOTAL CAPACITY COEFFICIENTS
C--------A (2, N) - A/C SENSIBLE CAPACITY COEFFICIENTS
C--------A (3, N) - A/C COMPRESSOR POWER + BY-PASS FACTOR COEFFICIENTS
C  NOTE: A VALUES MUST START IN THE FIRST LINE OF TAPE16!
C  CORRELATIONS ARE OF THE FORM:
C   A(I,1) - COEFFICIENT ON OUTDOOR DRY BULB TEMP(IN DEG F)
C   A(I,2) - COEF ON AIR FLOW RATE (IN CFM) THROUGH INDOOR COIL 
C   A(I,3) - COEF ON RETURN AIR WET BULB TEMP(IN DEG F)
C   A(I,4) - CONSTANT
C   A(I,5) - COEF ON OUTDOOR DRY BULB TEMP SQUARED
C   A(I,6-8) - NOT CURRENTLY USED
         READ(16, *,END=991) (A (I, J), J=1, 8)
         WRITE(60,  511) (A (I, J), J=1, 8)
80       CONTINUE
       
         CLOSE(16)
C
         IREAD=1
       ENDIF
C
      TCS=TCLAT0
      IF(TCLAT1.LT.TCS) TCS=TCLAT1
      IF(TCEQP0.LT.TCS) TCS=TCEQP0
      IF(TCEQIP.LT.TCS) TCS=TCEQIP
C
C
      A13=A(1,3)*REDC
      A23=A(2,3)*REDC
      A33=A(3,3)*REDC
C     BF=A(3,5)+A(3,6)*ECFMC1
C     BFECFM=4.5*CPAIR*(1.-BF)*ECFMC1*REDC
      A120=(A(1,2)*ECFMC1+A(1,4))*REDC
      A220=(A(2,2)*ECFMC1+A(2,4))*REDC
      A320=(A(3,2)*ECFMC1+A(3,4))*REDC
      A121=A(1,1)*REDC
      A221=A(2,1)*REDC
      A321=A(3,1)*REDC
      A122=A(1,5)*REDC
      A222=A(2,5)*REDC
      A322=A(3,5)*REDC
      TCN=0.
      DS=0.
      XLCN=0.
      SHCN=0.
      POW=0.
      XLCC0=DTIME/TCLAT0
      XLCC1=DTIME/TCLAT1
      SHCC0=DTIME/TCEQP0
      SHCC1=DTIME/TCEQIP
C
C  BELOW WAS IN HUMDF BEFORE 8/85
C  CONS13 HAS UNITS OF BTU/R/HR
      CONS13(1)=ECFMC2*4.5*CPAIR
      CONS13(2)=ECFMC2*4.5*CPAIR*REDC
      CONS13(3)=ECFMH1*4.5*REDH*CPAIR
      CONS13(4)=ECFMC1*4.5*CPAIR*REDC
C---END IN HUMDF
      RETURN
C
C  OUTDOOR DRY-BULB TEMP KNOWN(TODDB)  2-MIN. TIMESTEP HERE
      ENTRY ACND1(IBLOW,TRETWB,TRETB)
   20 A12=A120+A121*TODDB + A122*TODDB**2
      A22=A220+A221*TODDB + A222*TODDB**2
      A32=A320+A321*TODDB + A322*TODDB**2
      RETURN
C
C  WET-BULB TEMP AT INLET TO INDOOR COIL KNOWN( RETWB)  20 SEC TIMESTEP
      ENTRY ACND2(IBLOW,TRETWB,TRETB)
      ISKIP=1
C
      CALL ZERV(7,QEXT,QVENTB,QVNTLS,QVENTA,QDRAFT,QJACK,POW,
     +            DM1,DM2,DM3)
      TCT=1.E-20
      SHCT=1.E-20
C  IS A/C ON?
      IF(IAC.EQ.0)GO TO 30
      TCT=(A12+A13*TRETWB)*1000.*ACAPFAC
      SHCT=(A22+A23*TRETWB)*1000.*ACAPFAC
      POW=(A32+A33*TRETWB)*APOWFAC
C
C  CORRECT SENSIBLE CAPACITY FOR DRY-BULB OTHER THAN 80 F
      SHCT=SHCT+AFAC*ECFMC1*(TRETB-80.)*1000.*ACAPFAC
      IF(SHCT.GT.TCT)SHCT=TCT
C
      IF(TRETWB.LT.TCAP) THEN
         IF(TRETWB.LT.TCAP-DTCAP) THEN
            TCT=SHCT
         ELSE
            TCT=TCT-(TCT-SHCT)*(TCAP-TRETWB)/DTCAP
         ENDIF
      ENDIF
C
C  CODE TO ALLOW A VARIABLE DTIME - FOR ANALYSIS OF MEASURED DATA
C
 30   IF(DTIME.NE.DS) THEN
         XLCC0=DTIME/TCLAT0
         XLCC1=DTIME/TCLAT1
         SHCC0=DTIME/TCEQP0
         SHCC1=DTIME/TCEQIP
         IACLS=-1
      ENDIF
      DS=DTIME
C
C  FIND TRANSIENT INSTANTANEOUS CAPACITIES
      IF(IAC.EQ.IACLS)GO TO 32
      IF(IAC.EQ.1)THEN
          XLCC=XLCC1
          SHCC=SHCC1
      ELSE
          XLCC=XLCC0
          SHCC=SHCC0
          ENDIF
      NLOOP=DTIME*5./TCS+1
      RNLOOP=1./NLOOP
      IF(IDEBUG.EQ.1) WRITE(60,100) TCT,SHCT,POW,DTIME,TCS,NLOOP
 100  FORMAT(1X,'ACOND - TCT,SHCT,POW,DTIME,TCS,NLOOP ',5E11.3,I5)
C
C  USE SMALLER TIME STEP OF DTIME/NLOOP TO OBTAIN
C  DIFFERENCE EQUATION STABILITY AND ACCURACY
C
 32   DO 34 I=1,NLOOP
      XLCN=XLCC*RNLOOP*((TCT-SHCT)-XLCN)+XLCN
 34   SHCN=SHCC*RNLOOP*(SHCT-SHCN)+SHCN
C
      IF(SHCN.LT.0.)SHCN=0.
      IF(XLCN.LT.0.)XLCN=0.
      TCN=SHCN+XLCN
      IF(TCN.GT.TCT.AND.IAC.GT.0)THEN
          RAT=TCT/TCN
          XLCN=RAT*XLCN
          TCN=TCT
          SHCN=RAT*SHCN
          ENDIF
C  BELOW WAS IN HUMDF BEFORE 8/85
C
C  RDF'S OPINION(8/85): RECOVC SHOULD ALWAYS BE INPUT AS ZERO
      RECC=(1.-RECOVC)*IAC+RECOVC
      TCR=TCN*RECC
      SHCR=SHCN*RECC
      I10=1+IAC+2*IBLOW
      TB=TRETB-SHCR/CONS13(I10)
      IF(IDEBUG.EQ.1) WRITE(60,110) TRETB,TB,TCR,SHCR,CONS13(I10),I10
 110  FORMAT(1X,'ACOND - TRETB,TB,TCR,SHCR,CONS13(I10),I10 ',5E11.3,I5)
C
C  END---IN HUMDF
C
      TA2=TB
      CALL PLENM1
C
C  MOISTURE REMOVED
      WMOIST=(TCR-SHCR)/1061.
      IACLS=IAC
      RETURN
   99 WRITE(60,*)' ACOND: EOF ON TAPE16 LOOKING FOR NAMELIST INPAC'
      STOP ' ACOND: EOF ON TAPE16 LOOKING FOR NAMELIST INPAC'
  991 WRITE(60,*)' ACOND: EOF ON TAPE16 READING A() DATA'
      STOP ' ACOND: EOF ON TAPE16 READING A() DATA'
 510  FORMAT (1X,'AIR CONDITIONER COEFFICIENTS (TC,SHC,POW)')
 511  FORMAT (8E16.5)
      END
