      SUBROUTINE HUMDF(TI)
C 
C  HUMIDIFIER MODEL 
C  REF. BULLOCK,C.E.,RESIDENTIAL CENTRAL HEATING SYSTEM HUMIDIFIER
C       COMPUTER SIMULATION AND APPLICATION GUIDELINES, ASHRAE PAPER
C       NO. AT-78-8, NO.3, 1978
C  NOT USED BY BCL....
CMDK CPAIR
CMDK NZN
CMDK HUMIDC
CMDK WIBLK
C 
      REAL LE,MWOUT,MWIN
      DATA AREA,THK/144.,2.25/
C ***   HUMIDIFIER READ - IN
C ***    MWI - SUPPLY WATER FLOW RATE, LB/HR
C ***    TWI - SUPPLY WATER TEMP,DEG F
C ***    CFMBP - BYPASS AIR FLOW RATE, CFM
C ***    HSTC - HUMIDISTAT TIME CONSTANT, MIN 
C ***    SETHS - HUMIDISTAT SET POINT, %
C ***    DIFFHS - HUMIDISTAT DIFFERENTIAL , % 
      READ(5,*) MWI,TWI,CFMBP,HSTC,SETHS,DIFFHS 
      IF ( CFMBP .LE. 0.) GO TO 147 
      WRITE(60,2250) MWI,TWI,CFMBP,HSTC,SETHS,DIFFHS
      LE = 0.9
      VOL = AREA*THK/1728.
      VEL = CFMBP/AREA*144. 
      HDAV = 8.217*VEL+2135.
      HSTC = HSTC/60. 
      WA1=4.5*CFMBP 
      F1=HDAV*VOL/WA1 
      F1LE= F1*LE 
      VOLWA1=VOL/WA1
      HDAVLE= HDAV*LE 
      DMDTW=.1
      F1B= F1/(1.+F1/2.)
      F1C= (1.-F1/2.)/(1.+F1/2.)
      F2= F1LE*CPAIR
      CPA2=1./(CPAIR+F2/2.) 
      HDAVLC= HDAVLE*CPAIR
      QSPP= (TWI-32.)*MWI 
  147 CONTINUE
           RETURN
C 
      ENTRY HUMDF1(TI)
C ***   SET HUMIDIFIER STATES 
      TWOUT = TWI 
      QSP=0.
      QWA=0.
      QHUM=0. 
      WBULK=WI(1) 
      HIN=CPAIR*TI+1061.*WI(1)
      TBULK=TI
      RETURN
C 
      ENTRY HUMDF3(TI)
C 
C ***      $$$$$$$$$  HUMIDIFIER CALCULATIONS  $$$$$$$$$
      IF (CFMBP .LE.0.0) GO TO 630
      IF(IHUM.EQ.1) GO TO 580 
C ***   IF HUMIDIFIER IS OFF, INLET=OUTLET CONDITIONS 
      QSP=0.
      QHUM=0. 
      QWA=0.
      TWOUT = TWI 
      WBULK=WAC 
      TBULK=TB
      GO TO 630 
C ***   START OF HUMIDIFER FINE TIME STEPS
580   LTW=0 
      HIN=CPAIR*TB+1061.*WAC
      ITW=1 
C ***   START OF HUMIDIFIER LUMP CALCULATIONS 
582   TM = TWOUT
      IF(TM.LT.32.) TM = 32.
      F = (((1.14204D-9*TM-5.73544D-8)*TM-8.2068D-5)*TM+4.57702D-2)*TM
     +    -6.95562
      WSM = EXP(F)
      WBULK = F1B*WSM+F1C*WAC 
      WBAR = (WAC+WBULK)*.5 
      HGM= 1061.+.45*TM 
      R1 = HDAV*(WSM-WBAR)
      F3 = R1*HGM*VOLWA1
      TBULK= (F2*(TM-TB*.5)+HIN-1061.*WBULK+F3)*CPA2
      IF(TBULK.LT.TWOUT) TBULK=TWOUT
      TBAR = (TB+TBULK)*.5
      R2 = HDAVLC*(TM-TBAR)+R1*HGM
      MWOUT = MWI - R1*VOL
      AH = R2*VOL 
      BH = MWI*(TWOUT-TWI)
      CH = R1*VOL*(TWOUT-32.) 
      DF3DTM= (R1*VOL*.45+HGM*DMDTW)/WA1
      DWBULK=F1B*WSM*(((4.56816D-9*TM-17.20632D-8)*TM-16.4136D-5)*TM+ 
     * 4.57702D-2)
C **** MWIN NOT SET IN ORIGINAL PROGRAM 
      MWIN=0. 
      DTBULK= (F2-1061.*DWBULK+DF3DTM)*CPA2 
      ABC= (AH+BH-CH)/((HDAVLC*(1.-DTBULK*.5)-.55*R1)*VOL+MWIN+ 
     * (1093.-.55*TM)*DMDTW)
      IF (LINES .LT. ITER) WRITE(60,2330) ABC,TM,DMDTW,TB 
      IF(ABS(ABC).LT.0.01)GO TO 620 
      IF (ITW .EQ. 2) GO TO 584 
      ITW=2 
      ABC1=ABC
      DM=MWOUT
      TWOUT=TWOUT-ABC 
      GO TO 582 
584   TWOUT=TWOUT+ABC1*ABC/(ABC-ABC1) 
      DMDTW= (MWOUT-DM)/ABC1
      LTW=LTW+1 
      ITW=1 
      IF( LTW .LT. 10) GO TO 582
      WRITE(60,3030)
      STOP
620   QHUM = MWOUT*(TWOUT-TWI)+(MWI-MWOUT)*(1093.+.45*TBULK-TWI)
      QSP =QSPP 
      QWA = MWOUT*(TWOUT-32.) 
630   CONTINUE
      RETURN
2250  FORMAT (/' HUMIDISTAT PARAMETERS:'/ '   MWI       TWI     CFMBP 
     $    HSTC     SETHS     DIFFHS   '/ F8.2,F10.2,F10.1,F10.2,
     $ 2F10.4)
 2330 FORMAT('  ABC=',F8.3,'  TWOUT=',F8.2,'  DMDTW=',F8.3, 
     +'  TB=',F8.2) 
 3030 FORMAT('  NO CONVERGENCE IN HUMIDIFIER WATER TEMP LVG') 
      END 
