C  -- HOURLY --                                                                     
C PROGRAM TO CREATE INTEGRATED HOURLY DATA FROM DETAILED                
C ASHRAE DATA AND MODEL OUTPUT PROGRAM FILES                            
C                                                                       
C 11/26/83 FEJ                                                          
C 11/16/84 MODIFICATIONS FOR .GT.130 CHANNELS. FEJ                      
C        DATA(I,J)  I=DATA CHANNEL INDEX (CH1=TIME)                     
C                   J=TIME INDEX INTO THE HOUR                          
      DIMENSION DATA(150,2),AVE(150),ITIME(7),ITM(7)
      LOGICAL OK                                                        
      OPEN(7,FILE='TAPE7',STATUS='OLD')
      OPEN(1,FILE='HOURLY.OUT',STATUS='UNKNOWN')
      DATA DATA/300*0.0/,AVE/150*0.0/                                   
      DATA MAXCH/150/,ITIMQ/0/                                                   
C                                                                       
    1 CONTINUE                                                          
   10 CONTINUE                                                          
      NEOF2=0
   20 CONTINUE                                                          
      OK=.FALSE.                                                        
      READ(7,2010,IOSTAT=IO2,END=900) TIME,(ITIME(I),I=1,7)                     
      IF(TIME.EQ.0..AND.ITIMQ.EQ.1)GO TO 900
      IF(ITIME(7).GT.1980.AND.ITIME(7).LT.1990) OK=.TRUE.               
      IF(IO2.EQ.0 .AND. OK ) THEN                                       
         BACKSPACE 7                                                    
	  BACKSPACE 7
      ELSE IF(IO2.GT.0) THEN                                      
         CLOSE(7)
	  OPEN(7)
         NEOF2=NEOF2+1                                                  
         IF(NEOF2.GT.2) STOP 'NO DATA FOUND ON TAPE7'                   
         GO TO 20                                                       
      ELSE                                                              
         GO TO 10                                                       
      ENDIF                                                             
      IF(ITIME(6).GT.MAXCH) THEN                                        
         PRINT*,'NOT ENOUGH CHANNELS DIMENSIONED..',ITIME               
         STOP 'NEED MORE SPACE (DIMENSIONS)'                            
      ENDIF                                                             
      PRINT 2011,1,TIME,ITIME   
      ITIMQ=1                            
      NEOF2=0                                                           
  110 CONTINUE                                                          
C                                                                       
C        INITIALIZE SUMS                                                
C                                                                       
      DO 115 I=1,ITIME(6)                                               
      AVE(I)=0.0                                                        
  115 CONTINUE                                                          
C                                                                       
C           READ 1ST TIME RECORD IN AN HOUR                             
C                                                                       
         NTIME=0                                                        
  116    READ(7,2010,END=900,IOSTAT=IO2)                         
     +   TM1,(ITM(I),I=1,7)
         IF(IO2.NE.0)GO TO 900
         IF(TM1.EQ.0.)GO TO 116
	  DATA(1,1)=TM1
	  DO 117 I=1,7
  117    ITIME(I)=ITM(I)
C         PRINT 2011,2,DATA(1,1),(ITIME(I),I=1,7)
         READ(7,2012,END=900,IOSTAT=IO2)(DATA(I,1),I=2,ITIME(6))         
         IF(IO2.NE.0)GO TO 900
         NTIME=NTIME+1                                                  
         TFIRST=DATA(1,1)                                               
	  IHRLS=ITIME(2)
  120    CONTINUE                                                       
         READ(7,2010,END=900,IOSTAT=IO2)                         
     +   TM2,(ITM(I),I=1,7)
         IF(IO2.NE.0)GO TO 900
         IF(TM2.EQ.0.)GOTO 120
	  DATA(1,2)=TM2
	  DO 121 I=1,7
  121    ITIME(I)=ITM(I)
         IF(DATA(1,2).EQ.0.)GO TO 900
C         PRINT 2011,3,DATA(1,2),(ITIME(I),I=1,7)
         READ(7,2012,END=900,IOSTAT=I02)(DATA(I,2),I=2,ITIME(6))         
         IF(IO2.NE.0)GO TO 900
         NTIME=NTIME+1                                                  
         DT=DATA(1,2)-DATA(1,1)                                         
         AVE(1)=AVE(1)+DT                                               
         DT=DT*0.5                                                      
         DO 260 I=2,ITIME(6)                                            
            AVE(I)=AVE(I)+(DATA(I,2)+DATA(I,1))*DT                      
            DATA(I,1)=DATA(I,2)                                         
  260    CONTINUE           
         TSECND=DATA(1,2)                                            
	  IHR=ITIME(2)
	  IF(IHRLS.NE.IHR)GO TO 270
         DATA(1,1)=DATA(1,2)                                            
         GO TO 120                                                      
C                                                                       
  270 IF( (ABS(AVE(1)-1.0)) .GT. (1.0E-3) ) THEN                        
      IF(AVE(1).NE.0.) THEN                                             
         RAVE=1.0/AVE(1)                                                
         DO 310 I=2,ITIME(6)                                            
            AVE(I)=AVE(I)*RAVE                                          
  310    CONTINUE                                                       
      ELSE                                                              
         GO TO 10                                                       
      ENDIF                                                             
      ENDIF                                                             
C                                                                       
      TIME= (TFIRST+TSECND)*0.5                                      
      ITIME(1)=TIME/24.                                                 
      ITIME(2)=TIME-ITIME(1)*24.                                        
      ITIME(3)= (TIME-IFIX(TFIRST))*60                               
      ITIME(4)=0                                                        
      ITIME(5)=0      
      WRITE(1,2010) TIME,(ITIME(I),I=1,7)
      WRITE(1,2012) (AVE(I),I=2,ITIME(6))                                          
      GO TO 110                                                         
C                                                                       
  900 CONTINUE                                                          
      ENDFILE 1                                                         
      PRINT 2013,TIME,ITIME,TSECND                             
      STOP 'END OF HOURLY PROGRAM'                                      
C                                                                       
 2010 FORMAT(F12.5,I4,5I3,I5)
 2011 FORMAT(1X,' GOOD TIME AT ',I2,F12.5,I4,5I3,I5)
 2012 FORMAT(8E10.4/8E10.4/8E10.4/8E10.4/8E10.4/
     +8E10.4/8E10.4/7E10.4)                                  
 2013 FORMAT(1X,' LAST HRLY TIME WRITTEN....',F12.5,I4,5I3,I5/
     +1X,' LAST TIME READ= ',F12.5)
 2020 FORMAT(32X,A3)                                                    
C                                                                       
      END                                                               
      