ECHO OFF
REM  --  RUNHBK.BAT FILE CONTENTS  --
REM   USED TO RUN PC-VERSION OF HOUSE_II MULTIZONE MODEL
REM   USAGE:  RUN PITT H1A
REM     WHERE THE 1ST PARAMETER IS THE WEATHER DATA FILE
REM           THE 2ND PARAMETER IS A RUNTAG (ALL DATA FILES,
REM     INCLUDING THE WEATHER DATA FILES HAVE .DAT EXTENSION)
REM     -- RUNTAG: H1 IS HBK CASE 1, A IS RUN LETTER 
REM     THE RUNTAG WILL BE ADDED TO: FUR1A"RUNTAG".DAT, CNTRL"RUNTAG".DAT,
REM     TSTAT"RUNTAG".DAT, INGSF"RUNTAG".DAT FILES.
COMMAND /C C:\HII\SCR\README NO
IF NOT EXIST C:\HII\DAT  MD C:\HII\DAT
IF NOT EXIST C:\HII\DAT\%2 MD C:\HII\DAT\%2
ECHO More information on handbook factors in TAPE25 and > C:\HII\DAT\%2\README
ECHO TAPES 33 to 37 and definition of heat flows printed >> C:\HII\DAT\%2\README
ECHO along with the output data in file HII%2.OUT is >> C:\HII\DAT\%2\README
ECHO available in ref. no. 3 in file \HII\SCR\S2.DOC >> C:\HII\DAT\%2\README
ECHO and ASHRAE 1988 Equipment Handbook, pages 24.8-24.17. >> C:\HII\DAT\%2\README
ECHO Relative humidity swings in TAPE1 and air temp swings >> C:\HII\DAT\%2\README
ECHO in TAPE11 are for the last 24 hrs of the case >> C:\HII\DAT\%2\README
IF EXIST TAPE1 DEL TAPE1
IF EXIST TAPE3 DEL TAPE3
IF EXIST TAPE3 DEL TAPE6
IF EXIST TAPE7 DEL TAPE7
IF EXIST TAPE8 DEL TAPE8
IF EXIST TAPE9 DEL TAPE9
IF EXIST TAPE11 DEL TAPE11
IF EXIST TAPE17 DEL TAPE17
IF EXIST TAPE18 DEL TAPE18
IF EXIST TAPE19 DEL TAPE19
IF EXIST TAPE23 DEL TAPE23
IF EXIST TAPE24 DEL TAPE24
IF EXIST TAPE31 DEL TAPE31
IF EXIST TAPE32 DEL TAPE32
IF EXIST TAPE33 DEL TAPE33
IF EXIST TAPE34 DEL TAPE34
IF EXIST TAPE35 DEL TAPE35
IF EXIST TAPE36 DEL TAPE36
IF EXIST TAPE37 DEL TAPE37
IF EXIST TAPE40 DEL TAPE40
IF EXIST TAPE41 DEL TAPE41
IF EXIST TAPE42 DEL TAPE42
IF EXIST TAPE51 DEL TAPE51
IF EXIST TAPE60 DEL TAPE60
IF EXIST HII%2.OUT DEL HII%2.OUT
IF EXIST INP.DAT DEL INP.DAT

REM    GET THE CONTROL,TSTAT, AND COLLECT FILES
COPY CNTRL%2.DAT TAPE30
COPY TSTAT%2.DAT TAPE15
COPY INPCOLLH.DAT TAPE14

REM    GET THE MAIN RUN AND FURNACE FILE
COPY FUR1A%2.DAT TAPE5
COPY INGSF%2.DAT TAPE12

REM   GET THE AIR-CONDITIONER FILE
COPY INPAC.DAT TAPE16

REM    GET THE DUCT AND ZONE-FLOWS DATA FILES
COPY ADUCT%2.DAT+ZNFLW%2.DAT TAPE2

REM    GET THE GROUND MODEL DATA
COPY GROUNDH.DAT TAPE18

REM    GET THE CITY DATA FILE
COPY BCTY.DAT TAPE4

REM    GET THE STRUCTURE FILE
COPY STRMZ%2.DAT TAPE10

REM    GET THE ATTACHED GARAGE FILE
COPY GARAGH.DAT TAPE17

COPY TAPE30+TAPE15+TAPE14+TAPE5+TAPE12+TAPE16+TAPE2+TAPE18+TAPE4+TAPE10+TAPE17 INP.DAT

REM    GET THE WEATHER FILE
COPY C:\HII\WTHR\%1.DAT TAPE40

REM    GET THE STARTING TIME!
TIMC > TIMI

REM    RUN THE SP43 MULTIZONE MODEL
C:\HII\HOUS_II

REM     GET THE STOPPING TIME!
TIMC > TIMS

PAUSE   LOOKEE HERE... AAWL DONE!  ANY RUN-TIME MESSAGES?
CLS
REM    CONSOLIDATE MAIN OUTPUT FILES TO A SINGLE FILE  HII%2.OUT
COPY TIMI+RUN.BAT+INP.DAT+TAPE60+TIMI+TIMS C:\HII\DAT\%2\HII%2.OUT
REM  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
REM    MISC OUTPUT FILES ARE:
REM      TAPE1   Swings in relative humidity for 24 hours -- There wont
REM              be any swings for heating without a humidifier (CFANBP=0.
REM              in file FUR1AH1A.DAT and read in HUMDF.FOR)
REM      TAPE3   File of burner,tstat,and damper events and TI's
REM      TAPE7   CDATA file (for input to C:\HII\POST\HOURLY program to
REM              get hrly data)  Caution:  This file is as large as
REM              17 megabytes for a 5-day period so limit the interval
REM              on file INPCOLLH.DAT to minimize the length of this file.
REM              Note that this file wont get created if you set ICOLL=0
REM              in file CNTRLH1A.DAT.
REM      TAPE8   Detailed Q-flows file
REM      TAPE9   Hourly Q-flows file
REM      TAPE11  Save zone-air-temp swing data for 24 hours. (At the end
REM              of the run, this file will contain data for the final 24 hrs)
REM      TAPE21  Cooling system output file 
REM      TAPE25  Handbook reference net loads
REM        NOTE:  You should supply this file as TAPE25 with HBKRNL = 1.
REM               I put code into HBKF to print it if it isnt there, however.
REM      TAPE31  Handbook output daily Q-flows
REM      TAPE32  Handbook output daily handbook factors
REM             NOTE:  You can deactivate (not write) files TAPE33-36 by
REM                    setting I33T36=0 in file CNTRLH1A.DAT
REM      TAPE33  Handbook output daily HROUT array
REM      TAPE34  Handbook output daily HRPRT array
REM      TAPE35  Handbook output monthly OUTDY array
REM      TAPE36  Handbook output monthly SEASUM ARRAY
REM      TAPE37  Handbook output daily handbook total energy (7 values)
REM      TAPE51  Furnace burner event file (for input to GASSUM to get fuel
REM              usage)
REM      TAPE60  OUTPUT DATA
REM  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DEL TIMI
DEL TIMS
DEL INP.DAT
IF EXIST TAPE2 DEL TAPE2
IF EXIST TAPE4 DEL TAPE4
IF EXIST TAPE5 DEL TAPE5
IF EXIST TAPE10 DEL TAPE10
IF EXIST TAPE12 DEL TAPE12
IF EXIST TAPE13 DEL TAPE13
IF EXIST TAPE14 DEL TAPE14
IF EXIST TAPE15 DEL TAPE15
IF EXIST TAPE16 DEL TAPE16
IF EXIST TAPE17 DEL TAPE17
IF EXIST TAPE18 DEL TAPE18
REM   TAPE19 IS THE SOLARH DATA USED DURING THE RUN!
IF EXIST TAPE19 DEL TAPE19
IF EXIST TAPE23 DEL TAPE23
IF EXIST TAPE24 DEL TAPE24
IF EXIST TAPE30 DEL TAPE30
REM     (TAPES 25,31-37 ARE FOR HANDBOOK RUNS)
IF EXIST TAPE40 DEL TAPE40
IF EXIST TAPE41 DEL TAPE41
IF EXIST TAPE42 DEL TAPE42
REM    TAPE43 IS THE GROUND TEMPS AFTER PRECONDITIONING
REM    THAT CAN BE USED TO REDUCE EXECUTION TIME FOR SUBSEQUENT
REM    RUNS BY SETTING IGINIT= -2 IN FILE GROUNDH.DAT
IF EXIST TAPE45 DEL TAPE45
IF EXIST TAPE1 COPY TAPE1 C:\HII\DAT\%2
IF EXIST TAPE3 COPY TAPE3 C:\HII\DAT\%2
IF EXIST TAPE8 COPY TAPE8 C:\HII\DAT\%2
IF EXIST TAPE9 COPY TAPE9 C:\HII\DAT\%2
IF EXIST TAPE11 COPY TAPE11 C:\HII\DAT\%2
IF EXIST TAPE25 COPY TAPE25 C:\HII\DAT\%2
IF EXIST TAPE31 COPY TAPE31 C:\HII\DAT\%2
IF EXIST TAPE32 COPY TAPE32 C:\HII\DAT\%2
IF EXIST TAPE33 COPY TAPE33 C:\HII\DAT\%2
IF EXIST TAPE34 COPY TAPE34 C:\HII\DAT\%2
IF EXIST TAPE35 COPY TAPE35 C:\HII\DAT\%2
IF EXIST TAPE36 COPY TAPE36 C:\HII\DAT\%2
IF EXIST TAPE37 COPY TAPE37 C:\HII\DAT\%2
IF EXIST TAPE51 COPY TAPE51 C:\HII\DAT\%2
IF EXIST TAPE1 DEL TAPE1
IF EXIST TAPE3 DEL TAPE3
IF EXIST TAPE8 DEL TAPE8
IF EXIST TAPE9 DEL TAPE9
IF EXIST TAPE11 DEL TAPE11
IF EXIST TAPE21 DEL TAPE21
IF EXIST TAPE25 DEL TAPE25
IF EXIST TAPE31 DEL TAPE31
IF EXIST TAPE32 DEL TAPE32
IF EXIST TAPE33 DEL TAPE33
IF EXIST TAPE34 DEL TAPE34
IF EXIST TAPE35 DEL TAPE35
IF EXIST TAPE36 DEL TAPE36
IF EXIST TAPE37 DEL TAPE37
IF EXIST TAPE51 DEL TAPE51
REM    Your output is in directory C:\HII\DAT\%2
REM       The main output file is HII%2.OUT!!!!!
REM       Handbook files are TAPE25,TAPE31-TAPE37!!!
REM
